#!/usr/bin/env node

require('./simple-monitoring.js');

const needle = require('needle');
const express = require('express');
const app = express();

app.use(express.json());
app.use(express.text({type:"*/*"}));
app.use(express.urlencoded({ extended: true })); // for parsing application/x-www-form-urlencoded

const port = process.argv[2] || 6900;

const processRequest = (req, res) => {
    const body = {
        message: `${req.method} ${req.url} processed`,
    };
    res.status(200).end(JSON.stringify(body));
};

app.use('/hello', (req, res) => {
    console.log(`Got ${req.method} ${req.url}`);

    processRequest(req, res); 
});

app.use('/proxy_call', (req, res) => {
    console.log(`Proxying ${req.method} ${req.url}`);

    needle('GET', 'http://example.com').then(response => {
        const body = {
            message: response.body
        };
        res.status(200).end(JSON.stringify(body));
    }).catch(error => {
        const body = {
            message: error.message
        };
        res.status(200).end(JSON.stringify(body));
    });
});

app.listen(port, () => {
    console.log(`Echo server is listnening on port ${port}`);
});

